<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>Nodejs-demo-NestJs-and-BDD documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	   <link rel="stylesheet" href="../styles/style.css">
        <link rel="stylesheet" href="../styles/dark.css">
        <link rel="stylesheet" href="../styles/postmark.css">
    </head>
    <body>
          <script>
               // Blocking script to avaoid flickering dark mode
               // Dark mode toggle button
               var useDark = window.matchMedia('(prefers-color-scheme: dark)');
               var darkModeState = useDark.matches;
               var $darkModeToggleSwitchers = document.querySelectorAll('.dark-mode-switch input');
               var $darkModeToggles = document.querySelectorAll('.dark-mode-switch');
               var darkModeStateLocal = localStorage.getItem('compodoc_darkmode-state');

               function checkToggle(check) {
                    for (var i = 0; i < $darkModeToggleSwitchers.length; i++) {
                         $darkModeToggleSwitchers[i].checked = check;
                    }
               }

               function toggleDarkMode(state) {
                    if (window.localStorage) {
                         localStorage.setItem('compodoc_darkmode-state', state);
                    }

                    checkToggle(state);

                    const hasClass = document.body.classList.contains('dark');

                    if (state) {
                         for (var i = 0; i < $darkModeToggles.length; i++) {
                              $darkModeToggles[i].classList.add('dark');
                         }
                         if (!hasClass) {
                              document.body.classList.add('dark');
                         }
                    } else {
                         for (var i = 0; i < $darkModeToggles.length; i++) {
                              $darkModeToggles[i].classList.remove('dark');
                         }
                         if (hasClass) {
                              document.body.classList.remove('dark');
                         }
                    }
               }

               useDark.addEventListener('change', function (evt) {
                    toggleDarkMode(evt.matches);
               });
               if (darkModeStateLocal) {
                    darkModeState = darkModeStateLocal === 'true';
               }
               toggleDarkMode(darkModeState);

               if ($darkModeToggles.length > 0) {
                    for (var i = 0; i < $darkModeToggleSwitchers.length; i++) {
                         $darkModeToggleSwitchers[i].addEventListener('change', function (event) {
                              darkModeState = !darkModeState;
                              toggleDarkMode(darkModeState);
                         });
                    }
               }
          </script>

        <div class="navbar navbar-default navbar-fixed-top d-block d-sm-none">
            <a href="../" class="navbar-brand">Nodejs-demo-NestJs-and-BDD documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content injectable">
                   <div class="content-data">








<ol class="breadcrumb">
  <li class="breadcrumb-item">Injectables</li>
  <li class="breadcrumb-item" >FakeBackApiService</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="nav-item">
            <a href="#info" 
                class="nav-link"
                class="nav-link active"
                role="tab" id="info-tab" data-bs-toggle="tab" data-link="info">Info</a>
        </li>
        <li class="nav-item">
            <a href="#source" 
                class="nav-link"
                
                role="tab" id="source-tab" data-bs-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/fake-third-app/services/fake-back-api.service.ts</code>
        </p>





            <section data-compodoc="block-index">
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#errorContext" >errorContext</a>
                            </li>
                            <li>
                                <a href="#units" >units</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#basicDetails" >basicDetails</a>
                            </li>
                            <li>
                                <a href="#createUnit" >createUnit</a>
                            </li>
                            <li>
                                <a href="#deleteUnit" >deleteUnit</a>
                            </li>
                            <li>
                                <a href="#error" >error</a>
                            </li>
                            <li>
                                <a href="#getUnitById" >getUnitById</a>
                            </li>
                            <li>
                                <a href="#getUnits" >getUnits</a>
                            </li>
                            <li>
                                <a href="#newUnitId" >newUnitId</a>
                            </li>
                            <li>
                                <a href="#ok" >ok</a>
                            </li>
                            <li>
                                <a href="#resetAllUnits" >resetAllUnits</a>
                            </li>
                            <li>
                                <a href="#updateUnit" >updateUnit</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section data-compodoc="block-constructor">
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(logger: Logger)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="33" class="link-to-prism">src/fake-third-app/services/fake-back-api.service.ts:33</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>logger</td>
                                                  
                                                        <td>
                                                                    <code>Logger</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

            <section data-compodoc="block-methods">
    
    <h3 id="methods">
        Methods
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="basicDetails"></a>
                    <span class="name">
                        <span ><b>basicDetails</b></span>
                        <a href="#basicDetails"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>basicDetails(unit: <a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank">any</a>)</code>
                </td>
            </tr>


                    <tr>
                        <td class="col-md-4">
                            <div class="io-line">Defined in <a href="" data-line="197"
                                    class="link-to-prism">src/fake-third-app/services/fake-back-api.service.ts:197</a></div>
                        </td>
                    </tr>


            <tr>
                <td class="col-md-4">

                            <div class="io-description">
                                <b>Parameters :</b>
                                
                                <table class="params">
                                    <thead>
                                        <tr>
                                            <td>Name</td>
                                                <td>Type</td>
                                            <td>Optional</td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                                <td>unit</td>
                                            <td>
                                                            <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>
                                            </td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        <div class="io-description">
                            <b>Returns : </b>    <code>{ id: any; code: any; label: any; photo: any; active: any; }</code>

                        </div>
                            <div class="io-description">
                                
                            </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="createUnit"></a>
                    <span class="name">
                        <span ><b>createUnit</b></span>
                        <a href="#createUnit"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>createUnit(body)</code>
                </td>
            </tr>


                    <tr>
                        <td class="col-md-4">
                            <div class="io-line">Defined in <a href="" data-line="87"
                                    class="link-to-prism">src/fake-third-app/services/fake-back-api.service.ts:87</a></div>
                        </td>
                    </tr>


            <tr>
                <td class="col-md-4">

                            <div class="io-description">
                                <b>Parameters :</b>
                                
                                <table class="params">
                                    <thead>
                                        <tr>
                                            <td>Name</td>
                                            <td>Optional</td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                                <td>body</td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        <div class="io-description">
                            <b>Returns : </b>    <code>Observable&lt;any&gt;</code>

                        </div>
                            <div class="io-description">
                                
                            </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="deleteUnit"></a>
                    <span class="name">
                        <span ><b>deleteUnit</b></span>
                        <a href="#deleteUnit"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>deleteUnit(id)</code>
                </td>
            </tr>


                    <tr>
                        <td class="col-md-4">
                            <div class="io-line">Defined in <a href="" data-line="158"
                                    class="link-to-prism">src/fake-third-app/services/fake-back-api.service.ts:158</a></div>
                        </td>
                    </tr>


            <tr>
                <td class="col-md-4">

                            <div class="io-description">
                                <b>Parameters :</b>
                                
                                <table class="params">
                                    <thead>
                                        <tr>
                                            <td>Name</td>
                                            <td>Optional</td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                                <td>id</td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        <div class="io-description">
                            <b>Returns : </b>    <code>Observable&lt;any&gt;</code>

                        </div>
                            <div class="io-description">
                                
                            </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="error"></a>
                    <span class="name">
                        <span ><b>error</b></span>
                        <a href="#error"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>error(message: <a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank">any</a>)</code>
                </td>
            </tr>


                    <tr>
                        <td class="col-md-4">
                            <div class="io-line">Defined in <a href="" data-line="192"
                                    class="link-to-prism">src/fake-third-app/services/fake-back-api.service.ts:192</a></div>
                        </td>
                    </tr>


            <tr>
                <td class="col-md-4">

                            <div class="io-description">
                                <b>Parameters :</b>
                                
                                <table class="params">
                                    <thead>
                                        <tr>
                                            <td>Name</td>
                                                <td>Type</td>
                                            <td>Optional</td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                                <td>message</td>
                                            <td>
                                                            <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>
                                            </td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        <div class="io-description">
                            <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>

                        </div>
                            <div class="io-description">
                                
                            </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="getUnitById"></a>
                    <span class="name">
                        <span ><b>getUnitById</b></span>
                        <a href="#getUnitById"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>getUnitById(id)</code>
                </td>
            </tr>


                    <tr>
                        <td class="col-md-4">
                            <div class="io-line">Defined in <a href="" data-line="69"
                                    class="link-to-prism">src/fake-third-app/services/fake-back-api.service.ts:69</a></div>
                        </td>
                    </tr>


            <tr>
                <td class="col-md-4">

                            <div class="io-description">
                                <b>Parameters :</b>
                                
                                <table class="params">
                                    <thead>
                                        <tr>
                                            <td>Name</td>
                                            <td>Optional</td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                                <td>id</td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        <div class="io-description">
                            <b>Returns : </b>    <code>Observable&lt;any&gt;</code>

                        </div>
                            <div class="io-description">
                                
                            </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="getUnits"></a>
                    <span class="name">
                        <span ><b>getUnits</b></span>
                        <a href="#getUnits"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>getUnits(paginationQuery?: <a href="../classes/PaginationQueryDto.html" target="_self">PaginationQueryDto</a>)</code>
                </td>
            </tr>


                    <tr>
                        <td class="col-md-4">
                            <div class="io-line">Defined in <a href="" data-line="41"
                                    class="link-to-prism">src/fake-third-app/services/fake-back-api.service.ts:41</a></div>
                        </td>
                    </tr>


            <tr>
                <td class="col-md-4">

                            <div class="io-description">
                                <b>Parameters :</b>
                                
                                <table class="params">
                                    <thead>
                                        <tr>
                                            <td>Name</td>
                                                <td>Type</td>
                                            <td>Optional</td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                                <td>paginationQuery</td>
                                            <td>
                                                            <code><a href="../classes/PaginationQueryDto.html" target="_self" >PaginationQueryDto</a></code>
                                            </td>

                                            <td>
                                                    Yes
                                            </td>


                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        <div class="io-description">
                            <b>Returns : </b>    <code>Observable&lt;any&gt;</code>

                        </div>
                            <div class="io-description">
                                
                            </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="newUnitId"></a>
                    <span class="name">
                        <span ><b>newUnitId</b></span>
                        <a href="#newUnitId"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>newUnitId()</code>
                </td>
            </tr>


                    <tr>
                        <td class="col-md-4">
                            <div class="io-line">Defined in <a href="" data-line="202"
                                    class="link-to-prism">src/fake-third-app/services/fake-back-api.service.ts:202</a></div>
                        </td>
                    </tr>


            <tr>
                <td class="col-md-4">

                        <div class="io-description">
                            <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>

                        </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="ok"></a>
                    <span class="name">
                        <span ><b>ok</b></span>
                        <a href="#ok"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>ok(body?: <a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank">any</a>)</code>
                </td>
            </tr>


                    <tr>
                        <td class="col-md-4">
                            <div class="io-line">Defined in <a href="" data-line="188"
                                    class="link-to-prism">src/fake-third-app/services/fake-back-api.service.ts:188</a></div>
                        </td>
                    </tr>


            <tr>
                <td class="col-md-4">

                            <div class="io-description">
                                <b>Parameters :</b>
                                
                                <table class="params">
                                    <thead>
                                        <tr>
                                            <td>Name</td>
                                                <td>Type</td>
                                            <td>Optional</td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                                <td>body</td>
                                            <td>
                                                            <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>
                                            </td>

                                            <td>
                                                    Yes
                                            </td>


                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        <div class="io-description">
                            <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>

                        </div>
                            <div class="io-description">
                                
                            </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="resetAllUnits"></a>
                    <span class="name">
                        <span ><b>resetAllUnits</b></span>
                        <a href="#resetAllUnits"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>resetAllUnits()</code>
                </td>
            </tr>


                    <tr>
                        <td class="col-md-4">
                            <div class="io-line">Defined in <a href="" data-line="178"
                                    class="link-to-prism">src/fake-third-app/services/fake-back-api.service.ts:178</a></div>
                        </td>
                    </tr>


            <tr>
                <td class="col-md-4">

                        <div class="io-description">
                            <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                        </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="updateUnit"></a>
                    <span class="name">
                        <span ><b>updateUnit</b></span>
                        <a href="#updateUnit"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>updateUnit(id, body)</code>
                </td>
            </tr>


                    <tr>
                        <td class="col-md-4">
                            <div class="io-line">Defined in <a href="" data-line="112"
                                    class="link-to-prism">src/fake-third-app/services/fake-back-api.service.ts:112</a></div>
                        </td>
                    </tr>


            <tr>
                <td class="col-md-4">

                            <div class="io-description">
                                <b>Parameters :</b>
                                
                                <table class="params">
                                    <thead>
                                        <tr>
                                            <td>Name</td>
                                            <td>Optional</td>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                                <td>id</td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                        <tr>
                                                <td>body</td>

                                            <td>
                                                    No
                                            </td>


                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        <div class="io-description">
                            <b>Returns : </b>    <code>Observable&lt;any&gt;</code>

                        </div>
                            <div class="io-description">
                                
                            </div>
                </td>
            </tr>
        </tbody>
    </table>
</section>
            <section data-compodoc="block-properties">
    
    <h3 id="inputs">
        Properties
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="errorContext"></a>
                    <span class="name">
                        <span ><b>errorContext</b></span>
                        <a href="#errorContext"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Type : </i>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="32" class="link-to-prism">src/fake-third-app/services/fake-back-api.service.ts:32</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="units"></a>
                    <span class="name">
                        <span ><b>units</b></span>
                        <a href="#units"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Type : </i>        <code><a href="../classes/UnitsDto.html" target="_self" >UnitsDto</a></code>

                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="33" class="link-to-prism">src/fake-third-app/services/fake-back-api.service.ts:33</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
</section>

    </div>


    <div class="tab-pane fade  tab-source-code" id="source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Inject, Injectable, NotFoundException } from &#x27;@nestjs/common&#x27;;
import {
  delay,
  dematerialize,
  materialize,
  Observable,
  of,
  throwError,
} from &#x27;rxjs&#x27;;
import { v4 as uuidv4 } from &#x27;uuid&#x27;;
import { Buffer } from &#x27;buffer&#x27;;
import { WINSTON_MODULE_PROVIDER } from &#x27;nest-winston&#x27;;
import { Logger } from &#x27;winston&#x27;;

/*
Make sure to add these settings in the compilerOptions section of your file tsconfig.json:
&quot;resolveJsonModule&quot;: true,
&quot;esModuleInterop&quot;: true,
*/
import unitsJson from &#x27;../data/units.json&#x27;;
import { UnitsDto } from &#x27;../dto/units.dto&#x27;;
import { UnitEntity } from &#x27;../entities/unit.entity&#x27;;
import store from &#x27;store&#x27;;
import { PaginationQueryDto } from &#x27;../dto/pagination-query.dto&#x27;;

// array in local storage for units
const unitsKey &#x3D; &#x27;units-mock&#x27;;
const unitsJsonLocal &#x3D; unitsJson;

@Injectable()
export class FakeBackApiService {
  errorContext: string;
  units: UnitsDto;

  constructor(
    @Inject(WINSTON_MODULE_PROVIDER) private readonly logger: Logger,
  ) {
    this.errorContext &#x3D; &#x27;FakeThirdAppModule.FakeBackApiService&#x27;;
  }

  getUnits(paginationQuery?: PaginationQueryDto): Observable&lt;any&gt; {
    try {
      this.logger.debug(&#x60;${this.errorContext}.getUnits().begun&#x60;);
      const { limit, offset, keyword } &#x3D; paginationQuery;
      this.units &#x3D; store.get(unitsKey)
        ? JSON.parse(store.get(unitsKey))
        : unitsJsonLocal;
      let filteredObj &#x3D; Object.assign({}, this.units);
      // return ok(units.map(x &#x3D;&gt; basicDetails(x)));
      if (keyword &amp;&amp; keyword !&#x3D; &#x27;&#x27;)
        filteredObj.results &#x3D; filteredObj.results.filter((item) &#x3D;&gt; {
          return item.label.includes(keyword);
        });
      if (offset &amp;&amp; offset !&#x3D; &#x27;&#x27;)
        filteredObj.results &#x3D; filteredObj.results.slice(parseInt(offset, 10));
      if (limit &amp;&amp; limit !&#x3D; &#x27;&#x27;)
        filteredObj.results &#x3D; filteredObj.results.slice(0, parseInt(limit, 10));
      filteredObj.results &#x3D; filteredObj.results.map((x) &#x3D;&gt;
        this.basicDetails(x),
      );
      return this.ok(filteredObj);
    } catch (err) {
      const errorMessage: string &#x3D; &#x60;${this.errorContext}.getUnits().failed: ${err}&#x60;;
      this.logger.error(errorMessage);
      throw errorMessage;
    }
  }

  getUnitById(id): Observable&lt;any&gt; {
    try {
      this.logger.debug(&#x60;${this.errorContext}.getUnitById().begun&#x60;);
      this.units &#x3D; store.get(unitsKey)
        ? JSON.parse(store.get(unitsKey))
        : unitsJsonLocal;
      const unit &#x3D; this.units.results.find((x) &#x3D;&gt; x.id &#x3D;&#x3D;&#x3D; id);
      if (!unit) {
        throw new NotFoundException(&#x60;Unit #${id} not found&#x60;);
      }
      return this.ok(this.basicDetails(unit));
    } catch (err) {
      const errorMessage: string &#x3D; &#x60;${this.errorContext}.getUnitById().failed: ${err}&#x60;;
      this.logger.error(errorMessage);
      throw errorMessage;
    }
  }

  createUnit(body): Observable&lt;any&gt; {
    try {
      this.logger.debug(&#x60;${this.errorContext}.createUnit().begun&#x60;);
      this.units &#x3D; store.get(unitsKey)
        ? JSON.parse(store.get(unitsKey))
        : unitsJsonLocal;
      const unit &#x3D; body;

      if (this.units.results.find((x) &#x3D;&gt; x.code &#x3D;&#x3D;&#x3D; unit.code)) {
        throw Error(&#x60;Unit with the code ${unit.code} already exists&#x60;);
      }

      // assign unit id and a few other properties then save
      unit.id &#x3D; this.newUnitId();
      this.units.results.push(unit);
      store.set(unitsKey, JSON.stringify(this.units));

      return this.ok(this.basicDetails(unit));
    } catch (err) {
      const errorMessage: string &#x3D; &#x60;${this.errorContext}.createUnit().failed: ${err}&#x60;;
      this.logger.error(errorMessage);
      throw errorMessage;
    }
  }

  updateUnit(id, body): Observable&lt;any&gt; {
    try {
      this.logger.debug(&#x60;${this.errorContext}.updateUnit().begun&#x60;);
      this.units &#x3D; store.get(unitsKey)
        ? JSON.parse(store.get(unitsKey))
        : unitsJsonLocal;
      let params &#x3D; body;
      let unitIndex: number;
      let unit &#x3D; this.units.results.find((x, index) &#x3D;&gt; {
        if (x.id &#x3D;&#x3D;&#x3D; id) {
          unitIndex &#x3D; index;
          return true;
        }
      });

      if (!unit) {
        throw new NotFoundException(&#x60;Unit #${id} not found&#x60;);
      }

      /*
      if (
        params.code !&#x3D;&#x3D; unit.code &amp;&amp;
        this.units.results.find((x) &#x3D;&gt; x.code &#x3D;&#x3D;&#x3D; params.code)
      ) {
        throw Error(&#x60;Unit with the code ${params.code} already exists&#x60;);
      }
      */

      // only update password if entered
      if (!params.password) {
        delete params.password;
      }

      // update and save unit
      const updatedUnit &#x3D; Object.assign(unit, params);
      this.units.results[unitIndex] &#x3D; updatedUnit;
      store.set(unitsKey, JSON.stringify(this.units));

      return this.ok(this.basicDetails(unit));
    } catch (err) {
      const errorMessage: string &#x3D; &#x60;${this.errorContext}.updateUnit().failed: ${err}&#x60;;
      this.logger.error(errorMessage);
      throw errorMessage;
    }
  }

  deleteUnit(id): Observable&lt;any&gt; {
    try {
      this.logger.debug(&#x60;${this.errorContext}.deleteUnit().begun&#x60;);
      const unit &#x3D; this.units.results.find((x) &#x3D;&gt; x.id &#x3D;&#x3D;&#x3D; id);
      if (!unit) {
        throw new NotFoundException(&#x60;Unit #${id} not found&#x60;);
      }
      this.units &#x3D; store.get(unitsKey)
        ? JSON.parse(store.get(unitsKey))
        : unitsJsonLocal;
      this.units.results &#x3D; this.units.results.filter((x) &#x3D;&gt; x.id !&#x3D;&#x3D; id);
      store.set(unitsKey, JSON.stringify(this.units));
      return this.ok(this.basicDetails(unit));
    } catch (err) {
      const errorMessage: string &#x3D; &#x60;${this.errorContext}.deleteUnit().failed: ${err}&#x60;;
      this.logger.error(errorMessage);
      throw errorMessage;
    }
  }

  resetAllUnits() {
    // Remove current selection
    store.remove(unitsKey);

    // Clear all keys
    // store.clearAll();
  }

  // helper functions

  ok(body?: any) {
    return of(body).pipe(delay(500)); // delay observable to simulate server api call
  }

  error(message: any) {
    this.logger.error(message);
    return of(message).pipe(materialize(), delay(500), dematerialize()); // call materialize and dematerialize to ensure delay even if an error is thrown (https://github.com/Reactive-Extensions/RxJS/issues/648);
  }

  basicDetails(unit: any) {
    const { id, code, label, photo, active } &#x3D; unit;
    return { id, code, label, photo, active };
  }

  newUnitId() {
    let myuuid &#x3D; uuidv4();
    // base64 encoding
    myuuid &#x3D; Buffer.from(myuuid).toString(&#x27;base64&#x27;).substring(0, 20);
    // return units.results.length ? Math.max(...units.results.map(x &#x3D;&gt; x.id)) + 1 : 1;
    return myuuid;
  }
}
</code></pre>
    </div>

</div>













                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> results matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

          <label class="dark-mode-switch">
               <input type="checkbox">
               <span class="slider">
                    <svg class="slider-icon" viewBox="0 0 24 24" fill="none" height="20" stroke="#000" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" width="20" xmlns="http://www.w3.org/2000/svg">
                    <path d="M21 12.79A9 9 0 1111.21 3 7 7 0 0021 12.79z"></path>
                    </svg>
               </span>
          </label>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'injectable';
            var COMPODOC_CURRENT_PAGE_URL = 'FakeBackApiService.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>

       <script src="../js/menu-wc.js" defer></script>
       <script nomodule src="../js/menu-wc_es5.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
